﻿; reval v1.10 ejn (blueznl)
; pb 5.50 x86
; purebasic regular expressions evaluator
; bluez@xs4all.nl
;
; - using parts of the x_lib to manipulate the editor gadget
; - using parts of the g_spot to resize gadgets on the fly
; - bascically a quick hack / expansion on a little example i posted on the forum...
;
#reval_version = "v1.10"
#reval_copyright="c2010..2017 EJN"
;
EnableExplicit
IncludeFile "..\x_lib\x_lib.pb"
IncludeFile "..\g_spot\g_spot.pb"
Declare reval_main()
Declare reval_init()
Declare reval_end()
;
x_init()
gs_init()
reval_init()
reval_main()
reval_end()
gs_end()
x_end()

Procedure reval_history()
  ;
  ; v1.10
  ;
  ; - updated link to ninelizards
  ; - recompiled in 5.50 x86
  ;
  ; v1.09
  ;
  ; - modified for pb 3.50
  ; - increased font size
  ; - using newer x_lib
  ; - compiled with 5.20b7
  ;
  ; v1.06
  ;
  ; - cleaned up code
  ; - changed layout
  ; - added box for extracted elements
  ; - compiled with 4.61 beta
  ; - improved x_littlehelp allows non-asci compileing
  ;
EndProcedure

Procedure reval_init()
  ;
  ; *** initialize variables and constants
  ;
  ;
  ; all gui elements, menu entries, gadgets
  ;
  Enumeration
    ;
    #w_main_nr
    ;
    #m_main
    ;
    #f_exit
    #f_none
    #f_dotall
    #f_extended
    #f_multiline
    #f_anynewline
    ;
    #f_purebasic_forum
    #f_purebasic_documentation
    #f_survival_guide
    #f_regular_expressions_info
    #f_you_dont_know_anything
    #f_quickhelp
    ;
    #g_pattern_t
    #g_pattern
    #g_status
    #g_text_t
    #g_text
    #g_extracted_t
    #g_extracted
    ;
    #i_status
    ;
  EndEnumeration
  ;
  LoadFont(1,"Courier New",x_defaultpurebasicfontsize*1.2)
  ;
  ; on-board quickhelp
  ;
  DataSection
    license:
    IncludeBinary "reval.txt"
    Data.w 0,0
  EndDataSection
  Global p_license = ?license
  ;
  ; event handling
  ;
  Global action.i, event.i, event_menu.i
  ;
EndProcedure

Procedure callback_handler(windowid.l,message.l,wparam.l,lparam.l)
  Protected *nmhdr.NMHDR
  Protected *nmlvcustomdraw.NMLVCUSTOMDRAW
  Protected gadget_h.l, item_nr.l
  Select message
      Case #WM_NOTIFY
        *nmlvcustomdraw = lparam                              ; use to do custom drawing
        *nmhdr.NMHDR = lparam                                 ; use to grab tab key
        gadget_h = *nmhdr\hwndFrom                            ; handle of gadget that caused event
        If GetAsyncKeyState_(#VK_TAB) = 32768                 ; this is all about processing tab keys etc.
          Select gadget_h
              Case GadgetID(#g_text)
                SetActiveGadget(#g_pattern)
                ProcedureReturn 1
              Case GadgetID(#g_pattern)
                SetActiveGadget(#g_extracted)
                ProcedureReturn 1
              Case GadgetID(#g_extracted)
                SetActiveGadget(#g_text)
                ProcedureReturn 1
          EndSelect
        EndIf
      Case #WM_SIZE
        gs_apply()
  EndSelect
  ProcedureReturn #PB_ProcessPureBasicEvents              ; continue processing messages
EndProcedure

Procedure reval_main()
  Protected s.s, n.i, nn.i, nnn.i, nnnn.i, x.i, y.i
  Protected expression_nr.i, expression_old.s, text.s, text_old.s, expression.s, flags.i, flags_old.i
  Protected extracted.s, extracted_n.i
  Protected Dim extract_results.s(1)
  ;
  ; *** create image, menus, gadgets
  ;
  CreateImage(#i_status,9,22)
  ;
  OpenWindow(#w_main_nr,10,10,400,387," REval "+#reval_version+" - "+#reval_copyright,#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget)
  ; SmartWindowRefresh(#w_main_nr,1)
  WindowBounds(#w_main_nr,160,300,#PB_Ignore,#PB_Ignore)
  SetWindowCallback(@callback_handler())
  ;
  CreateMenu(#m_main,WindowID(#w_main_nr))
  MenuTitle("File")
  MenuItem(#f_exit,"Exit")
  MenuTitle("Flags")
  MenuItem(#f_dotall,"#PB_RegularExpression_DotAll")
  MenuItem(#f_extended,"#PB_RegularExpression_Extended")
  MenuItem(#f_multiline,"#PB_RegularExpression_MultiLine")
  MenuItem(#f_anynewline,"#PB_RegularExpression_AnyNewLine")
  MenuTitle("Help")
  MenuItem(#f_purebasic_documentation,"Regular Expression Syntax")
  MenuItem(#f_purebasic_forum,"PureBasic Forum")
  MenuItem(#f_survival_guide,"PureBasic Survival Guide")
  MenuItem(#f_you_dont_know_anything,"You don't know anything")
  MenuItem(#f_regular_expressions_info,"Regular-Expressions.info")
  MenuBar()
  MenuItem(#f_quickhelp,"Notes and License")
  AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F1,#f_quickhelp)
  ;
  ; using x_editorgadget because i want to grab the tab key
  ;
  TextGadget(#g_text_t,5,5,210,18,"Text (matches are highlighted)")
  x_EditorGadget(#g_text,5,23,390,180,"","",#x_gadget_notify)
  TextGadget(#g_pattern_t,5,210,380,18,"Pattern")
  TextGadget(#g_extracted_t,5,210,185,18,"Extracted")
  ; StringGadget(#g_pattern,5,228,375,44,"")
  x_EditorGadget(#g_pattern,5,228,375,24,"","",#x_gadget_notify)
  ImageGadget(#g_status,385,228,10,18,ImageID(#i_status))
  x_EditorGadget(#g_extracted,5,278,390,80,"","",#x_gadget_notify)
  ;
  SetGadgetFont(#g_text,FontID(1))
  SetGadgetFont(#g_pattern,FontID(1))
  SetGadgetFont(#g_extracted,FontID(1))
  ;
  ; couple of rules to make sure width matches windows size, top box is resized, and remaining boxes are nicely stacked below
  ;
  gs_rule(0,#gs_setwidth,#gs_gadget,#g_text,#gs_window,#w_main_nr,-10,10)
  gs_rule(0,#gs_setwidth,#gs_gadget,#g_pattern,#gs_window,#w_main_nr,-30,10)
  gs_rule(0,#gs_setwidth,#gs_gadget,#g_extracted,#gs_window,#w_main_nr,-10,10)
  gs_rule(0,#gs_alignparentright,#gs_gadget,#g_status,#gs_window,#w_main_nr,5)
  gs_rule(0,#gs_setheight,#gs_gadget,#g_text,#gs_window,#w_main_nr,-210,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_text,#gs_gadget,#g_text_t,2,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_pattern_t,#gs_gadget,#g_text,5,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_pattern,#gs_gadget,#g_pattern_t,2,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_status,#gs_gadget,#g_pattern_t,2,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_extracted_t,#gs_gadget,#g_pattern,9,0)
  gs_rule(0,#gs_below,#gs_gadget,#g_extracted,#gs_gadget,#g_extracted_t,2,0)
  ;
  SetActiveGadget(#g_text)
  ;
  ; event loop
  ;
  Repeat
    action = #f_none
    event = WaitWindowEvent()
    event_menu = EventMenu()
    ;
    ; handle events
    ;
    Select event
        Case #PB_Event_Menu
          Select event_menu
              Case #f_exit
                action = #f_exit
                ;
              Case #f_dotall, #f_extended, #f_multiline, #f_anynewline
                SetMenuItemState(#m_main,event_menu,1-(GetMenuItemState(#m_main,event_menu)))
                flags =         GetMenuItemState(#m_main,#f_dotall) * #PB_RegularExpression_DotAll
                flags = flags + GetMenuItemState(#m_main,#f_extended) * #PB_RegularExpression_Extended
                flags = flags + GetMenuItemState(#m_main,#f_multiline) * #PB_RegularExpression_MultiLine
                flags = flags + GetMenuItemState(#m_main,#f_anynewline) * #PB_RegularExpression_AnyNewLine
                ;
              Case #f_purebasic_forum
                RunProgram("www.purebasic.fr/english/index.php")
              Case #f_purebasic_documentation
                RunProgram("www.purebasic.com/documentation/regularexpression/index.html")
              Case #f_survival_guide
                RunProgram("www.ninelizards.com/purebasic/purebasic%2015.htm#top")
              Case #f_regular_expressions_info
                RunProgram("www.regular-expressions.info/")
              Case #f_you_dont_know_anything
                RunProgram("http://net.tutsplus.com/tutorials/javascript-ajax/you-dont-know-anything-about-regular-expressions")
              Case #f_quickhelp
                HideWindow(#w_main_nr,#True)
                x_littlehelp(" REval "+#reval_version+" - "+#reval_copyright,"",p_license,#PB_Ascii)
                HideWindow(#w_main_nr,#False)
                SetActiveWindow(#w_main_nr)
                ;
          EndSelect
        Case #PB_Event_CloseWindow
          action = #f_exit
    EndSelect
    ;
    If action <> #f_exit
      ;
      ; get all gadget data
      ;
      text = GetGadgetText(#g_text)
      expression = GetGadgetText(#g_pattern)
      ;
      ; create the regular expression
      ;
      expression_nr = CreateRegularExpression(#PB_Any,expression,flags)
      If expression_nr = 0
        ;
        ; turn statusbox red if the regular expression is incorrect
        ;
        StartDrawing(ImageOutput(#i_status))
          Box(0,0,10,30,RGB($FF,$00,$00))
        StopDrawing()
        SetGadgetState(#g_status,ImageID(#i_status))
        ;
      ElseIf expression_old <> expression Or text_old <> text Or flags <> flags_old
        ;
        ; colour statusbox green if regular expression is correct, and something has changed
        ;
        StartDrawing(ImageOutput(#i_status))
          Box(0,0,10,30,RGB($00,$FF,$00))
        StopDrawing()
        SetGadgetState(#g_status,ImageID(#i_status))
        ;
        ; remember position cursor in the editorgadget
        ;
        x = x_editorgadget_cursorcolumn(#g_text)
        y = x_editorgadget_cursorrow(#g_text)
        ;
        ; empty extracted list
        ;
        extracted = ""
        extracted_n = 0
        ;
        ; paint every section of text that matches the regular expression yellow
        ;
        n = CountGadgetItems(#g_text)
        For nn = 0 To n-1
          s = GetGadgetItemText(#g_text,nn)
          x_editorgadget_select(#g_text,nn)
          If MatchRegularExpression(expression_nr,s)
            x_editorgadget_backcolor(#g_text,RGB($FF,$FF,$00))
            ;
            ; add 'extracted' data to the 'extracted' output
            ;
            nnn = ExtractRegularExpression(expression_nr,s,extract_results.s())
            nnnn = 0
            While nnnn < nnn
              If extracted = ""
                extracted = extract_results(nnnn)
              Else
                extracted = extracted + #LF$ + extract_results(nnnn)
              EndIf
              nnnn = nnnn+1
            Wend
            extracted_n = extracted_n+nnn
            ;
          Else
            x_editorgadget_backcolor(#g_text,RGB($FF,$FF,$FF))
          EndIf
        Next nn
        ;
        ; show all 'extract_results' data
        ;
        SetGadgetText(#g_extracted_t,"Extracted ("+Str(extracted_n)+")")
        SetGadgetText(#g_extracted,extracted)
        ;
        ; return cursor to original position
        ;
        x_editorgadget_select(#g_text,y,x)
        ;
        ; free regular expression
        ;
        FreeRegularExpression(expression_nr)
        ;
        ; store old values to detect changes
        ;
        expression_old = expression
        text_old = text
        flags_old = flags
        ;
      EndIf
    EndIf
    ;
  Until action = #f_exit
  CloseWindow(#w_main_nr)
  ;
EndProcedure

Procedure reval_end()
  ;
  FreeFont(1)
  ;
EndProcedure

; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 32
; Folding = g
; Markers = 312
; EnableAsm
; EnableThread
; EnableXP
; UseIcon = C:\software\icons\key_ctrl_c.ico
; Executable = reval.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; EnableCompileCount = 524
; EnableBuildCount = 19
; EnableExeConstant
; EnableUnicode